/**
 * This is a class that represents a university
 * which in this case is consisted of one or more labs
 * that each have a number of students in them.
 * @author Reza Frahabkhsh
 * @since 12/3/2021
 * @version 1.0
 */
public class Uni {
    private String uniName;
    private int Size;
    private int current;
    private Lab[] labs = new Lab[Size];
    public Uni(String name, int size) {
        uniName = name;
        Size = size;
    }

    /**
     * a method to add a given lab to the uni class
     * @param lab
     */
    public void enrollLab(Lab lab) {
        labs[current++] = lab;
    }

    /**
     * a method to update the size of the class after defining it
     */
    public void updateSize() {
        labs = new Lab[Size];
    }

    /**
     * a method to print all the information stored in the class
     */
    public void print() {
        System.out.println("----------------------------------------------------------------------------");
        System.out.println("Uni Name: " + uniName);
        for(int i = 0; i < current; i++) {
            int labSize = labs[i].getSize();
            int labCap = labs[i].getCapacity();
            labs[i].calculateAvg();
            int avg = labs[i].getAvg();
            String day = labs[i].getDay();
            System.out.println("Lab " + (i + 1) + ": Cap: " + labCap + " Day: " + day);
            for(int j = 0; j < labSize; j++) {
                Student[] sdt = labs[i].getStudents();
                String name = sdt[j].getFirstName();
                String id = sdt[j].getId();
                int grade = sdt[j].getGrade();
                System.out.println("std first name: " + name
                        + " std id:" + id
                        + " std grade:"+ grade);
            }
            System.out.println("Lab AVG: " + avg);
            System.out.println("----------------------------------------------------------------------------");
        }
    }
}
